=== debian/changelog ===
icewm (3.3.1-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 05 Feb 2023 22:03:10 +0100

icewm (3.3.0-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 01 Jan 2023 12:57:14 +0100

icewm (3.2.3-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Fri, 16 Dec 2022 19:35:49 +0100
