## icewm 3.3.2

=== debian/changelog ===
icewm (3.3.2-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Tue, 14 Mar 2023 16:11:28 +0200

icewm (3.3.1-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Tue, 24 Jan 2023 00:47:47 +0200
