## icewm 3.3.3

=== debian/changelog ===
icewm (3.3.3-1.0antix2) unstable; urgency=medium

  * make icewmbg non-executable

 -- anticapitalista <antix@operamail.com>  Mon, 17 Apr 2023 20:10:48 +0300

icewm (3.3.3-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 10 Apr 2023 13:36:10 +0300
