## icewm 3.3.4

=== debian/changelog ===
icewm (3.3.4-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 04 May 2023 14:16:19 +0300
