## icewm 3.3.5

=== debian/changelog ===
icewm (3.3.5-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 19 May 2023 19:00:01 +0300
