## icewm 3.4.0

=== debian/changelog ===
icewm (3.4.0-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release including better azerty support
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 05 Jun 2023 14:20:19 +0300
