## icewm 3.4.1

=== debian/changelog ===
icewm (3.4.1-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 23 Jul 2023 08:15:42 +0200

icewm (3.4.0-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 18 Jun 2023 13:46:37 +0200

icewm (3.3.5-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Tue, 30 May 2023 18:47:18 +0200

icewm (3.3.4-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Fri, 05 May 2023 18:17:48 +0200

icewm (3.3.3-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 16 Apr 2023 22:21:28 +0200

icewm (3.3.2-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Wed, 15 Mar 2023 19:04:08 +0100
