## icewm 3.4.2

=== debian/changelog ===
icewm (3.4.2-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 20 Sep 2023 11:27:35 +0300

icewm (3.4.1-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Sun, 23 Jul 2023 15:01:33 +0300
