## icewm 3.4.3

=== debian/changelog ===
icewm (3.4.3-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Tue, 03 Oct 2023 14:40:33 +0300
