## icewm 3.4.4

=== debian/changelog ===
icewm (3.4.4-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Thu, 02 Nov 2023 17:38:43 +0200
