=== src/CMakeLists.txt ===

# to use target_link_options
cmake_minimum_required(VERSION 3.13)

PROJECT(ICEWM CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED on)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckTypeSize)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckCXXCompilerFlag)

SET(CXXFLAGS_COMMON -pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -DHAVE_CONFIG_H -include "${CMAKE_BINARY_DIR}/config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

unset(icewm_libs)
unset(Intl_INCLUDE_DIRS)

macro(concat_dedup _result_var)
    set(${_result_var} ${ARGN})
    list(REMOVE_DUPLICATES ${_result_var})
endmacro()

option(AUTO_INC_HEADERS "Guess related headers and include in the build config (developer comfort feature)" off)
macro(do_auto_inc_headers _in_out_var)
    if(AUTO_INC_HEADERS)
        set(auto_inc_headers_tmp)
        foreach(src ${${_in_out_var}})
            list(APPEND auto_inc_headers_tmp ${src})
            cmake_path(REPLACE_EXTENSION src .h OUTPUT_VARIABLE h_cand)
            message("Looking for ${h_cand}")
            if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${h_cand}")
                list(APPEND auto_inc_headers_tmp "${h_cand}")
            endif()
        endforeach()
        list(REMOVE_DUPLICATES auto_inc_headers_tmp)
        set(${_in_out_var} ${auto_inc_headers_tmp})
    endif()
endmacro()

macro(pkg_check_or_fail _prefix _what)
    clear_pkg_config(${_prefix})
    pkg_check_modules(${_prefix} ${_what})
    if(NOT ${_prefix}_FOUND)
        message(FATAL_ERROR ${ARGN})
    endif()
endmacro()

# drop remainings variables of pkg_config's work from the current scope
macro(clear_pkg_config _prefix)
    foreach(_i "_LIBRARIES" "_LINK_LIBRARIES" "_LIBRARY_DIRS" "_LDFLAGS" "_LDFLAGS_OTHER" "_INCLUDE_DIRS" "_CFLAGS" "_CFLAGS_OTHER")
        unset("${_prefix}${_i}")
    endforeach()
endmacro()

# optimize for release if not defined explicitly, can be overriden with CMAKE_BUILD_TYPE "None"
if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
    SET(CMAKE_BUILD_TYPE Release)
endif()

# I don't need -rdynamic, thanks!
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

SET(CMAKE_REQUIRED_FLAGS )

CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden CXX_VHI)
if(CXX_VHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility=hidden)
endif()

CHECK_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden CXX_VIHI)
if(CXX_VIHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility-inlines-hidden)
endif()

# teach GCC7+ to interpret our comments
CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough=2 HAS_FALLTHROUGH_OPTION)
if(HAS_FALLTHROUGH_OPTION)
    list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough=2)
else()
    CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough HAS_FALLTHROUGH_OPTION)
    if(HAS_FALLTHROUGH_OPTION)
        list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough)
    endif()
endif()

option(CONFIG_IMLIB2 "Imlib2 image loader" on)
option(CONFIG_LIBPNG "PNGLIB image loader" off)
option(CONFIG_LIBJPEG "JPEGLIB image loader" off)
option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF image loader" off)
option(CONFIG_LIBRSVG "Support SVG icons using librsvg" off)
option(CONFIG_NANOSVG "Support SVG icons using nanosvg" off)
option(CONFIG_XPM "XPM image loader" on)
option(CONFIG_I18N "Define to enable internationalization" on)
option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
option(CONFIG_SESSION "Define to enable X session management" on)
option(CONFIG_EXTERNAL_TRAY "Define for external systray (deprecated)" off)
option(ENABLE_NLS "Enable Native Language Support" on)
option(ENABLE_LTO "Enable Link Time Optimization" off)
option(ENABLE_LOGEVENTS "Enable logging of X11 events" off)

set(LOGEVENTS ${ENABLE_LOGEVENTS})
SET(CONFIG_DEFAULT_THEME "default/default.theme" CACHE STRING "Name of default theme")
SET(CONFIG_DEFAULT_BACKGROUND "" CACHE STRING "Default background image or directory")
SET(CONFIG_UNICODE_SET "" CACHE STRING "Your iconv unicode set in machine endian encoding (e.g. WCHAR_T, UCS-4-INTERNAL, UCS-4LE, UCS-4BE)")
# turn off when empty, see config.h template for details
IF("" STREQUAL "${CONFIG_UNICODE_SET}")
    SET(CONFIG_UNICODE_SET OFF)
ELSE()
    MESSAGE(STATUS "Configured custom unicode set: ${CONFIG_UNICODE_SET}.")
ENDIF()
SET(XTERMCMD xterm CACHE STRING "Default terminal emulator for X11")

if(ENABLE_NLS OR CONFIG_I18N)
    find_library(CONFIG_LIBICONV iconv)
    if(CONFIG_LIBICONV)
        LIST(APPEND nls_LIBS iconv)
    endif()
# XXX: once cmake 3.20 became standard, replace this block with dependency on
# Intl::Intl interface target.
    include(FindIntl)
    if(Intl_FOUND)
        list(APPEND nls_LIBS ${Intl_LIBRARIES})
    endif()
endif()

if(ENABLE_LTO AND ${CMAKE_HOST_SYSTEM_NAME} MATCHES "Linux")
    # https://stackoverflow.com/questions/72218980/gcc-v12-1-warning-about-serial-compilation
    check_cxx_compiler_flag(-flto=auto USE_LTOAUTO)
    if(USE_LTOAUTO)
        list(APPEND CXXFLAGS_COMMON -flto=auto)
    else()
        list(APPEND CXXFLAGS_COMMON -flto)
    endif()
endif()

# the only used ones...
# for x in `cat funclist` ; do grep $x src/* lib/* && echo $x >> exlist ; done
# perl -e 'print "CHECK_FUNCTION_EXISTS($_ HAVE_".uc($_).")\n" for @ARGV' `cat exlist`
# perl -e 'print "#cmakedefine HAVE_".uc($_)."\n" for @ARGV' `cat exlist`
CHECK_FUNCTION_EXISTS(backtrace_symbols_fd HAVE_BACKTRACE_SYMBOLS_FD)
CHECK_FUNCTION_EXISTS(memrchr HAVE_MEMRCHR)
CHECK_FUNCTION_EXISTS(strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(sysctl HAVE_SYSCTL)
CHECK_FUNCTION_EXISTS(sysctlbyname HAVE_SYSCTLBYNAME)

# perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
# perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILE_CXX(sched.h HAVE_SCHED_H)
CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H "-include /usr/include/sched.h")
CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H "-include /usr/include/sys/types.h")
CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)

#########################################################
# fiting flags to options and available system features #
#########################################################

pkg_check_modules(fontconfig fontconfig)
pkg_check_modules(xrender REQUIRED xrender)
pkg_check_modules(xcomposite REQUIRED xcomposite)
pkg_check_modules(xdamage REQUIRED xdamage)
pkg_check_modules(xfixes REQUIRED xfixes)
pkg_check_modules(xext REQUIRED xext)
pkg_check_modules(x11 REQUIRED x11)

CHECK_LIBRARY_EXISTS(X11 XInternAtoms ${x11_LIBDIR} HAVE_XINTERNATOMS)

set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})

# It would be a good idea to use different names for the image options and do the
# logics here.  For now, this self-adapting code modifies the option variables.

set(HINT_CURSORS
[=[
 Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB2=on.
]=])

set(HINT_IMG_LOADERS
[=[
 There is a choice to be made between two image loaders.
 Either 'yimage_gdk' must be enabled by -DCONFIG_GDK_PIXBUF_XLIB=on,
 or 'imlib2' must be enabled by -DCONFIG_IMLIB2=on,
 or else 'yximage' must be enabled by -DCONFIG_LIBPNG=on.
 The latter requires -DCONFIG_XPM=on, while -DCONFIG_LIBJPEG=on is recommended.
 Support SVG icons with either -DCONFIG_LIBRSVG=on or -DCONFIG_NANOSVG=on.
 ]=] ${HINT_CURSORS})

# image configuration error check
if(CONFIG_IMLIB2 OR CONFIG_GDK_PIXBUF_XLIB)
    if (NOT CONFIG_LIBRSVG AND NOT CONFIG_NANOSVG)
        message(WARNING "Support for SVG icons was not enabled")
    endif()
elseif(CONFIG_XPM AND CONFIG_LIBPNG)
    if (NOT CONFIG_LIBJPEG)
        message(WARNING "LIBJPEG is advisable for backgrounds in icewmbg")
    endif()
    set(CONFIG_LIBRSVG off)
    set(CONFIG_NANOSVG off)
else()
    MESSAGE(FATAL_ERROR ${HINT_IMG_LOADERS})
endif()

if(CONFIG_IMLIB2)
    pkg_check_or_fail(libimlib2 imlib2 "IMLIB2 selected but Imlib2 dev files not found.")
    set(CONFIG_GDK_PIXBUF_XLIB off)
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${libimlib2_LDFLAGS})
endif()

if(CONFIG_GDK_PIXBUF_XLIB)
    pkg_check_or_fail(pixbuf gdk-pixbuf-xlib-2.0
        "GDX-PIXBUF image loader selected but its dev files were not found."
        ${HINT_IMG_LOADERS})
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${pixbuf_LDFLAGS})
endif()

# this is a) optional, b) loaded through pixbuf anyway
if (CONFIG_LIBRSVG)
    pkg_check_modules(librsvg librsvg-2.0)
    if(NOT librsvg_FOUND)
        message(WARNING
                "SVG image loader selected but librsvg-2.0 dev files not found."
                "SVG support will not be available.")
        set(CONFIG_LIBRSVG off)
    else()
        LIST(APPEND icewm_img_libs ${librsvg_LDFLAGS})
        set(CONFIG_NANOSVG off)
    endif()
endif()

if (CONFIG_NANOSVG)
    set(hub https://raw.githubusercontent.com/memononen/nanosvg/master/src)
    foreach(nano nanosvg.h nanosvgrast.h)
        message(STATUS "Checking for src/${nano}")
        set(src ${CMAKE_SOURCE_DIR}/src/${nano})
        if (NOT EXISTS ${src})
            set(url ${hub}/${nano})
            file(DOWNLOAD ${url} ${src} INACTIVITY_TIMEOUT 3 STATUS down)
            list(GET down 0 stat)
            list(GET down 1 mesg)
            if(NOT ${stat} EQUAL 0 OR NOT EXISTS ${src})
                message(WARNING "Cannot download ${url} to ${src}: ${mesg}")
                set(CONFIG_NANOSVG off)
                break()
            endif()
        endif()
    endforeach()
endif()

# cursor configuration error check
if(CONFIG_XPM)
    #ok
elseif(CONFIG_IMLIB2)
    #ok
else()
    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
endif()

if(CONFIG_XPM)
    pkg_check_or_fail(libxpm xpm "XPM image loader selected but libXpm dev files not found."
        ${HINT_IMG_LOADERS})
    LIST(APPEND icewm_img_libs ${libxpm_LDFLAGS})
endif()

if(CONFIG_LIBPNG)
    pkg_check_or_fail(libpng libpng "PNG image loader selected but libpng dev files not found."
        ${HINT_IMG_LOADERS})
    LIST(APPEND icewm_img_libs ${libpng_LDFLAGS})
endif()

if(CONFIG_LIBJPEG)
    pkg_check_or_fail(libjpeg libjpeg "JPEG image loader selected but libjpeg dev files not found."
        "Please install libjpeg-dev (or similar)."
        "Otherwise use -DCONFIG_LIBJPEG=off.")
    LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
endif()

IF(CONFIG_SESSION)
    LIST(APPEND sm_LIBS SM ICE)
ENDIF()

option(CONFIG_SHAPE "Define to enable transparent frame	decoration (titlebar borders), requests X shape extension." on)
# TODO: check the symbol: AC_CHECK_LIB([Xext],[XShapeCombineRectangles],
if(CONFIG_SHAPE AND NOT xext_FOUND)
    message(WARNING "Xext library not found, disabling CONFIG_SHAPE")
    set(CONFIG_SHAPE off)
endif()

if(CONFIG_XRANDR)
    pkg_check_modules(xrandr xrandr)
    IF(NOT xrandr_FOUND)
        message(WARNING "Xrandr library not found, disabling CONFIG_XRANDR")
        set(CONFIG_XRANDR off)
    ENDIF()
endif()

option(CONFIG_COREFONTS "Define to enable X11 core fonts" off)
option(CONFIG_XFREETYPE "Define to enable XFT support" on)
if(CONFIG_XFREETYPE)
    pkg_check_modules(xft xft>=2.0)
    IF(NOT xft_FOUND)
        message(WARNING "xft library (>=2.0) not found, disabling CONFIG_XFREETYPE")
        set(CONFIG_XFREETYPE off)
        set(CONFIG_COREFONTS on)
    ELSE()
        set(CONFIG_XFREETYPE_VALUE 2)
    ENDIF()
else()
    set(CONFIG_COREFONTS on)
endif()

set(ICESOUND "ALSA,AO,OSS,ESound" CACHE STRING "List of supported audio subsystems")
string(TOLOWER ${ICESOUND} ICESOUND)
message(STATUS "Checking audio subsystems for ICESOUND: ${ICESOUND}")
