=== debian/changelog ===
icewm (3.4.5-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:58:33 +1100

icewm (3.4.5-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:07:57 +0000

icewm (3.4.5-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 31 Dec 2023 10:05:28 +0100

icewm (3.4.4-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sat, 04 Nov 2023 16:01:14 +0100

icewm (3.4.3-1) unstable; urgency=medium

  * New upstream release
  * icewm-menu-xrandr: minor fix to avoid warnings where no custom
    configuration was added, also including the configuration example

 -- Eduard Bloch <blade@debian.org>  Sat, 07 Oct 2023 14:24:57 +0200

icewm (3.4.2-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Tue, 19 Sep 2023 20:27:41 +0200
