## icewm 3.4.6

=== debian/changelog ===
icewm (3.4.6-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 11 Mar 2024 18:11:51 +0200

icewm (3.4.5-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 29 Dec 2023 16:41:39 +0200
