## icewm 3.4.7

=== debian/changelog ===
icewm (3.4.7-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 05 Apr 2024 17:44:01 +0300
