=== debian/rules ===
--- 
+++ 
@@ -64,8 +64,8 @@
 #override_dh_auto_configure:
 #	$(MAKE) -f debian/rules -j2 config_normal config_lite
 
-override_dh_auto_build:
-	dh_auto_build -- all strtest
+#override_dh_auto_build:
+#	dh_auto_build -- all strtest
 #	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done
 
 #override_dh_auto_install:
@@ -102,12 +102,12 @@
 	dh_auto_clean
 
 override_dh_installchangelogs:
-	cat ChangeLog CHANGES > debian/changelog.mix
-	dh_installchangelogs -picewm-common debian/changelog.mix
+	dh_installchangelogs -picewm-common CHANGES
 
 override_dh_fixperms:
 	dh_fixperms
 	chmod a+rx,u+w "$(ICEWM_COMMON)/usr/share/doc/icewm-common/examples/startup"
+	chmod a+rwx,u-x,g-x,o-wx "$(ICEWM)/usr/bin/icewmbg"
 
 override_dh_compress:
 	dh_compress
