## icewm 3.5.0

=== debian/changelog ===
icewm (3.5.0-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Tue, 21 May 2024 00:30:06 +0300
