## icewm 3.5.1

=== debian/changelog ===
icewm (3.5.1-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 07 Jun 2024 16:04:56 +0300
